<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| Fast-Sales Pro                                                              |
| Copyright (c) 2007-2011 Fsales development group <support@fast-sales.ru>    |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://fast-sales.ru/fsales_pro_license.html          |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  Fsales     |
| development group (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  |
| OR MAKING AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE       |
| "SOFTWARE"). PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS       |
| LICENSE AGREEMENT CAREFULLY   BEFORE   INSTALLING   OR  USING  THE          |
| SOFTWARE.  BY INSTALLING, COPYING   OR   OTHERWISE   USING   THE            |
| SOFTWARE,  YOU  AND  YOUR  COMPANY (COLLECTIVELY,  "YOU")  ARE  ACCEPTING   |
| AND AGREEING  TO  THE TERMS OF THIS LICENSE   AGREEMENT.   IF  YOU    ARE   |
| NOT  WILLING   TO  BE  BOUND BY THIS AGREEMENT, DO  NOT INSTALL OR USE THE  |
| SOFTWARE.  VARIOUS   COPYRIGHTS   AND OTHER   INTELLECTUAL   PROPERTY       |
| RIGHTS    PROTECT   THE   SOFTWARE.  THIS AGREEMENT IS A LICENSE AGREEMENT  |
| THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE THE  SOFTWARE   AND  NOT  AN     |
| AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS|
| NOT EXPRESSLY GRANTED BY THIS AGREEMENT.                                    |
|                                                                             |
| The Initial Developers of the Original Code are Fsales development group    |
| Portions created by Fsales development group are Copyright (C) 2007-2009    |
| Fsales development group. All Rights Reserved.                              |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

/**
 * Simple script to combine JS files, to reduce the number of file request the server has to handle.
 */
 
define('FS_NO_AUTH', true);
define('ROOT_DIR', '../../../../');
	
require '../../../../setup.php';

// If no file requested
if (!isset($_GET['files']) or strlen($_GET['files']) == 0) {
	header('Status: 404 Not Found');
	exit;
}

// Cache folder
$cachePath = TMP_PATH;
if (!file_exists($cachePath)) {
	mkdir($cachePath);
}

// Tell the browser what kind of data to expect
header('Content-type: text/javascript');

// Enable compression
if (!empty($CONFIG['options']['zlib_compression_level']) && extension_loaded('zlib') && strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip') !== false) {
	ini_set('zlib.output_compression', 'On');
	ini_set('zlib.output_compression_level', $CONFIG['options']['zlib_compression_level']);
	header('Content-Encoding: gzip');
}

/**
 * Add file extension if needed
 * @var string $file the file name
 */
function addExtension($file) {
	if (substr($file, -3) !== '.js') {
		$file .= '.js';
	}
	
	return $file;
}

// Calculate an unique ID of requested files & their change time
$files = array_map('addExtension', explode(',', $_GET['files']));
$md5 = '';
foreach ($files as $file) {
	if (is_file($file)) {
		$filemtime = @filemtime($file);
		$md5 .= date('YmdHis', $filemtime ? $filemtime : NULL).$file;
	} else {
		header('HTTP/1.1 404 Not Found');
		header('Status: 404 Not Found');
		exit;
	}
}

$filename = 'admin-js-'.md5($md5);
$tmp = 60 * 60 * 24 * 365;

// If cache exists of this files/time ID
if (is_file($cachePath.$filename)) {
	$lastModifiedDate = filemtime($cachePath.$filename);
	
	if (isset($_SERVER['HTTP_IF_MODIFIED_SINCE']) && strtotime($_SERVER['HTTP_IF_MODIFIED_SINCE']) >= $lastModifiedDate) {
		header('HTTP/1.0 304 Not Modified');
	} else {
		session_cache_limiter('public');
		header('Cache-control: max-age='.$tmp);
		header('Expires: '.gmdate('D,d M Y H:i:s O', CURRENT_TIMESTAMP + $tmp));
		header('Last-Modified: '.gmdate('D, d M Y H:i:s', $lastModifiedDate).' GMT');
		readfile($cachePath.$filename);
	}
} else {
	error_reporting(0);
	
	$content = '';
	foreach ($files as $file) {
		$content .= file_get_contents($file);
	}
	
	session_cache_limiter('public');
	header('Cache-control: max-age='.$tmp);
	header('Expires: '.gmdate('D,d M Y H:i:s O', CURRENT_TIMESTAMP + $tmp));
	header('Last-Modified: '.gmdate('D, d M Y H:i:s', CURRENT_TIMESTAMP).' GMT');
	
	// Write cache file
	if (is_writable($cachePath)) {
		file_put_contents($cachePath.$filename, $content);
	}
	
	// Output
	echo $content;
}